



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Tomcat与Nginx、Apache结合的相关实践</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Tomcat与Nginx、Apache结合的相关实践</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 14:45:51 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>一、LNMT</p>
<p>　　简介：在Tomcat服务器前端部署一个Nginx(反向代理)，当用户请求静态资源时，由Nginx服务器负责响应；当用户请求java应用程序资源时，由后端的Tomcat服务器进行响应。</p>
<p>　　环境：</p>
<p>　　　　OS：Linux CentOS 6.8</p>
<p>　　　　Tomcat 6.0, IpAddr:192.168.1.101</p>
<p>　　　　Nginx 1.10.2, IpAddr:192.168.1.102</p>
<p>　　配置：</p>
<p>　　　　<strong>Tomcat</strong>端配置：　　</p>
<div>
<pre class="prettyprint linenums">/*定义一个主机*/<br />&lt;Host name="localhost"  appBase="webapps" unpackWARs="true" autoDeploy="true"  xmlValidation="false" xmlNamespaceAware="false"&gt;<br />　　　　/*定义一个Context:testapp应用程序*/<br />
    &lt;Context path="/test" docBase="testapp" reloadable="true" /&gt;<br />      /*定义第二个应用程序：test-1app*/<br />
    &lt;Context path="/test-1" docBase="test-1app" reloadable="true" /&gt;<br />
&lt;/Host&gt;</pre>
</div>
<p>　　　　<strong>Nginx</strong>端配置：</p>
<div>
<pre class="prettyprint linenums">server {<br />
    listen       80 default_server;<br />
    listen       [::]:80 default_server;<br />
    server_name  _;<br />
    root         /usr/share/nginx/html;

    # Load configuration files for the default server block.<br />
    include /etc/nginx/default.d/*.conf;

    /*处理静态资源请求*/<br />
    location / {<br />
    }

    /*Tomcat处理URL以jsp和do结尾的请求*/<br />
    location ~*\.(jsp|do)$ {<br />
        proxy_pass http://192.168.1.101:8080;<br />
    }

    /*Tomcat处理testapp应用请求*/<br />
    location /test/ {<br />
        proxy_pass http://192.168.1.101:8080/test/index1.jsp;<br />
    }

    /*Tomcat处理test-1app应用请求*/<br />
    location /test-1/demo.jsp {<br />
        proxy_pass http://192.168.1.101:8080;<br />
    }

    error_page 404 /404.html;<br />
        location = /40x.html {<br />
    }

    error_page 500 502 503 504 /50x.html;<br />
        location = /50x.html {<br />
    }<br />
}</pre>
</div>
<p>二、LAMT</p>
<p>　　简介：与LNMT类似，只不过是httpd作为反代服务器。但httpd反代tomcat有三种方式：</p>
<p>　　　　①基于httpd的proxy_module和proxy_http_module的反代</p>
<p>　　　　②基于httpd的proxy_module和proxy_ajp_module的反代</p>
<p>　　　　③基于httpd的mod_jk模块的反代(需自行编译安装)　</p>
<p>　　环境：</p>
<p>　　　　OS：Linux CentOS 6.8</p>
<p>　　　　Tomcat 6.0, IpAddr:192.168.1.101</p>
<p>　　　　httpd 2.2.15, IpAddr:192.168.1.102</p>
<p>　　配置：</p>
<p>　　　　第一种方式的实现：</p>
<p>　　　　<strong>Tomcat</strong>端配置与<strong>Nginx</strong>时配置相同，无需修改。</p>
<p>　　　　<strong>Httpd</strong>端配置：</p>
<div>
<pre class="prettyprint linenums">NameVirtualHost 192.168.1.102:80

&lt;VirtualHost 192.168.1.102:80&gt;<br />
  ServerName www.b.com<br />
  ProxyRequests Off<br />
  ProxyVia On<br />
  ProxyPreserveHost On<br />
  ProxyPass / http://192.168.1.101:8080<br />
  ProxyPassReverse / http://192.168.1.101:8080<br />
  &lt;Location /&gt;<br />
    Allow from all<br />
  &lt;/Location&gt;<br />
&lt;/VirtualHost&gt;

&lt;VirtualHost 192.168.1.102:80&gt;<br />
  ServerName www.c.com<br />
  ProxyRequests Off<br />
  ProxyVia On<br />
  ProxyPreserveHost On<br />
  ProxyPass / http://192.168.1.101:8080/test/index1.jsp<br />
  ProxyPassReverse / http://192.168.1.101:8080/test/index1.jsp<br />
  &lt;Location /&gt;<br />
    Allow from all<br />
  &lt;/Location&gt;<br />
&lt;/VirtualHost&gt;

&lt;VirtualHost 192.168.1.102:80&gt;<br />
  ServerName www.d.com<br />
  ProxyRequests Off<br />
  ProxyVia On<br />
  ProxyPreserveHost On<br />
  ProxyPass / http://192.168.1.101:8080/test-1/demo.jsp<br />
  ProxyPassReverse / http://192.168.1.101:8080/test-1/demo.jsp<br />
  &lt;Location /&gt;<br />
    Allow from all<br />
  &lt;/Location&gt;<br />
&lt;/VirtualHost&gt;</pre>
</div>
<p>　　　　如果是httpd2.4+版本，配置如下：</p>
<div>
<pre class="prettyprint linenums">&lt;VirtualHost 192.168.1.102:80&gt;<br />
  ServerName www.b.com<br />
  ProxyRequests Off<br />
  ProxyVia On<br />
  ProxyPreserveHost On<br />
  &lt;Proxy *&gt;<br />
     Require all granted<br />
  &lt;/Proxy&gt;<br />
  ProxyPass / http://192.168.1.101:8080<br />
  ProxyPassReverse / http://192.168.1.101:8080<br />
  &lt;Location /&gt;<br />
    Require all granted<br />
  &lt;/Location&gt;<br />
&lt;/VirtualHost&gt;</pre>
</div>
<p>　　　　第二种方式实现：</p>
<p>　　　　<strong>Tomcat</strong>端无需变动</p>
<p>　　　　<strong>Httpd</strong>端仅需修改协议和端口即可，配置如下：</p>
<div>
<pre class="prettyprint linenums">NameVirtualHost 192.168.1.102:80

&lt;VirtualHost 192.168.1.102:80&gt;<br />
  ServerName www.b.com<br />
  ProxyRequests Off<br />
  ProxyVia On<br />
  ProxyPreserveHost On<br />
  ProxyPass / ajp://192.168.1.101:8009<br />
  ProxyPassReverse / ajp://192.168.1.101:8009<br />
  &lt;Location /&gt;<br />
    Allow from all<br />
  &lt;/Location&gt;<br />
&lt;/VirtualHost&gt;

&lt;VirtualHost 192.168.1.102:80&gt;<br />
  ServerName www.c.com<br />
  ProxyRequests Off<br />
  ProxyVia On<br />
  ProxyPreserveHost On<br />
  ProxyPass / ajp://192.168.1.101:8009/test/index1.jsp<br />
  ProxyPassReverse / ajp://192.168.1.101:8009/test/index1.jsp<br />
  &lt;Location /&gt;<br />
    Allow from all<br />
  &lt;/Location&gt;<br />
&lt;/VirtualHost&gt;</pre>
</div>
<p>　　　　第三种方式实现：</p>
<p>　　　　请求流程：Client--&gt;http--&gt;httpd--&gt;mod_jk(ajp)--&gt;tomcat(http connector)</p>
<p>　　　　首先安装mod_jk模块：tomcat-connectors-1.2.42-src.tar.gz(依赖httpd-devel)</p>
<p>　　　　展开归档后进入native目录，执行</p>
<p>　　　　# ./configure --with-apxs=/usr/sbin/apxs</p>
<p>　　　　# make &amp;&amp; make install</p>
<p>　　　　安装完成，开始配置，</p>
<p>　　　　<strong>Tomcat</strong>端主机只需要在之前的基础上需改一个地方：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1041742/201701/1041742-20170116151900817-1835602797.png" /></p>
<p>　　　　在Engine中加入jvmRoute属性即可。</p>
<p>　　　　<strong>Httpd</strong>端的配置，需要两个配置文件：</p>
<p>　　　　　　①/etc/httpd/conf.d/workers.propeties</p>
<div>
<pre class="prettyprint linenums">worker.list=srv_A,StatA<br />
worker.srv_A.host=192.168.1.101<br />
worker.srv_A.port=8009<br />
worker.Tomcat.type=ajp13<br />
worker.StatA.type=status</pre>
</div>
<p>　　　　　　②/etc/httpd/conf.d/mod_jk.conf</p>
<div>
<pre class="prettyprint linenums">/*装载jk_module 路径是相对于/etc/httpd/下*/<br />
LoadModule jk_module modules/mod_jk.so

JkWorkersFile /etc/httpd/conf.d/workers.properies<br />
JkLogFile logs/mod_jk.log<br />
JkLogLevel notice<br />
JkMount /* srv_A       此处的"/"是以webapps为根<br />
JkMount /jk_status StatA</pre>
</div>
<p>　　　　</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2j0ov8.html">TCP&sol;IP协议三次握手与四次握手流程解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvpzy1q.html">Go1&period;7改善了编译速度并且会生成更快的代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gv3k49.html">ModalPopup</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vr5738.html">&lbrack;Flex&rsqb; IFrame系列 &mdash;&mdash; 嵌入本地页面两种方式source和content（html页面和html代码）</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vdy7m8.html">ExtJs之Ext&period;isEmpty</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn17dwx8.html">gcc编译通过，运行却显示&OpenCurlyDoubleQuote;段错误&rdquo;的解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd6j738.html">edit distance leetcode</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j6jno8.html">node&period;js之express框架入门篇</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz6nnl8.html">Python下载图片小程序</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y5y008.html">Neutron flat network 学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/95g0p7eq.html">python学习笔记---环境的安装，pip命令，数据类型，运算</a>
		</li>
						<li><a href="https://www.batexi.com/a/96071r49.html">Django url管理之include</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o152v5q.html">C&plus;&plus; GetComputerName&lpar;&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdye409.html">Linux wildcard</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2rp6pq.html">【你的职业规划】web前端的职业发展方向及学习攻略【转载】</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvyd038.html">DataTable导出为word&comma;excel&comma;html&comma;csv&comma;pdf&comma;&period;txt</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkggnd8.html">zabbix之运维疑难总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jmjr749.html">&period;Net-C&num;异步程序知识点梳理</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1jlke9.html">Windows 2008 R2防火墙设置运行被ping通</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkl3w18.html">完美配置Python3&period;5&plus;Anaconda&plus;PyQt5，实现UI和其他模块的结合</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q2jxv7v8.html">Android OpenGL ES（七）基本几何图形定义 &period;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8medv2rq.html">1988&colon; Sn 爆long long 的处理方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpm6579.html">&period;gitigore 相关</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdm67y9.html">Swift 学习笔记 （二）</a>
			</li>
						<li><a href="https://www.batexi.com/a/93yj1yz8.html">Jdk1&period;7环境变量的配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rg4l048.html">pycharm快捷键、常用设置、配置管理</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ey0kwj9.html">直接在script里面换样式IE6&comma;7&comma;8不兼容</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1dwo1q.html">c&num; 去除文本的html标签</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojd00lq.html">Python里如何实现C中switch&period;&period;&period;case的功能</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjo2oy8.html">CentOS服务端口开放</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
